#!/bin/bash
# /root/.icewm/lister2-icons.sh
# A more sideways menu variant for the icewm window manager.
#
# Copy from this forum thread and save 
# at the directory and with the filename above.
# (c) Christian L'Écuyer (aka musher0), Gatineau (Qc), Canada, Thursday July 9-11, 2020. 
# Licence: GPL2 
####
APPS=/usr/share/applications
cd $APPS
grep -m 1 Categories *.desktop | grep -E -v "default|jwm" | awk -F":" '{print $2";"$1}' | awk -F"=" '{print $2}' | awk -F";" '{print $1";"$NF}' | sort > liste
> liste2
while read line;do 
	if [ "${line:0:2}" = "X-" ];then 
		line="${line:2}"
	fi
	echo $line >> liste2
done < liste
sort liste2 > liste
rm liste2
#
mkdir -p /root/.icewm/construction
ConsTr="/root/.icewm/construction"
for i in Archiving AudioVideo Calculator Desktop Development Education Disk File Fun Game Graphic Internet Network Office Personal Science Security Setup Terminal;do
# Including the general, categories from Freedesktop.org at
# https://specifications.freedesktop.org/menu-spec/latest/apa.html
# in addition to those discovered through line 12.

		N="`grep -c $i liste`" # Check if something in list.
		if [ "$N" != "0" ];then
			grep $i liste | awk -F";" '{print $2}' > $ConsTr/$i.lst
		fi
done
# Special cases
N="";N="`grep -c Audio liste`"
[ "$N" != "0" ] && grep Audio liste | grep -v Video | awk -F";" '{print $2}' > $ConsTr/Audio.lst

N="";N="`grep -c Video liste`"
[ "$N" != "0" ] && grep Video liste | grep -v Audio | awk -F";" '{print $2}' > $ConsTr/Video.lst

M="";M="`grep -c Document liste`"
N="";N="`grep -c Editor liste`"
[ "$N" != "0" -o "$M" != "0" ] && grep -E "Document|Editor" liste | awk -F";" '{print $2}' > $ConsTr/Document.lst

N="";N="`grep -c Utility liste`"
[ "$N" != "0" ] && grep Utility liste | grep -E -v "Graphic|Personal|Setup" | awk -F";" '{print $2}' > $ConsTr/Utility.lst

#
cd $ConsTr
ls -1 *.lst > groupes
while read groupe;do
	Titr="${groupe%.*}"
	> $Titr.submenu
	echo "menu $Titr folder {
	separator" >> $Titr.submenu
		while read line;do
			Nom="${line%.*}"
			Icn="`grep -m 1 "Icon=" $APPS/$line`"
			Icn="${Icn#*=}" 
			echo "    prog $Nom $Icn rox $APPS/$line" >> $Titr.submenu
		done < $groupe
	echo "	separator
	}" >> $Titr.submenu
done < groupes
rm *.lst
# Grands groupes
echo "menu Activities folder {
separator" > Activities.submenu
cat Au*.submenu Calc*.submenu Do*.submenu Fun.submenu Gra*.submenu Int*.submenu Personal.submenu >> Activities.submenu
echo "separator 
}" >> Activities.submenu

echo "menu Technical folder {
separator" > Technical.submenu
cat Arch*.submenu Di*.submenu Net*.submenu S*.submenu Term*.submenu Util*.submenu >> Technical.submenu
echo "separator 
}" >> Technical.submenu

# Menu final
cat 000.submen Activ*.submenu Tech*.submenu zzz.submen > ../menu
rm *.submenu
cp ../menu ../menu.bkp
# The updated icewm menu is now ready.
